#
# shinGETsu - P2P anonymous BBS
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Message.pm,v 1.3 2004/05/05 12:38:36 fuktommy Exp $
#

package Shingetsu::Message;

#
# configuration
#
$filedir = $Shingetsu::Config::filedir;
$default = $Shingetsu::Config::language;

#
# constructor
#
sub new ($) {
	my($this) = @_;
	my $list = $ENV{HTTP_ACCEPT_LANGUAGE};
	local $_;
	my %q = ();
	my @lang = ();
	if ($list) {
		foreach (split /,/, $list) {
			if (/\s*;/) {
				my $lang = $`;
				if ($' =~ /q=\s*/) {
					$q{$lang} = $';
				}
			} else {
				$q{$_} = 1;
			}
		}
		@lang = sort {$q{$b} <=> $q{$a}} keys %q;
	}
	my $lang = $default;
	foreach (@lang) {
		if (-e "$filedir/message-$_.txt") {
			$lang = $_;
			last;
		}
	}

	my %message = ();
	open IN, "$filedir/message-$lang.txt" or die "faild to open $filedir/message-$lang.txt. $!";
	while (<IN>) {
		chomp;
		next if (/^#$/);
		my @buf = split /<>/;
		next if (@buf != 2);
		$buf[1] =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;
		$message{$buf[0]} = $buf[1];
	}
	close IN;
	return bless {%message};
}

1;
